/* Centaur Makefile Generator
 *
 * Version 2.0
 * 11/19/2020
 *
 * Main program
 *
 * main.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "makegen.h"

char _DEFAULTS[7][MAXLINELEN] = {"", "main", "main", "main.o", "main.o", "", "/usr/bin"};

int main(int argc, char *argv[])
{
	if (argc < 2)
	{
		mktmpfiles("c");
		if (!blank("._makegen_c.tmp"))
		{
			printf("%s: No C files in current directory\n", argv[0]);
			system("cat ._makegen_c.tmp");
			remove(CTEMPFILE);
			return 1;
		} else {
			remove(CTEMPFILE);
		}

		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.main_ofile, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.libs, _DEFAULTS[_LIBS]);
		strcpy(_makefile.install_dir, _DEFAULTS[_INSTALL_DIR]);
		create_makefile();
		delete_tmpfiles();	
		return 0;
	}
	
	if (argc == 2 && !strcmp(argv[1], "-h")) {
		printf(HELP_TEXT);
		return 0;
	}

	mktmpfiles("c");
	if (!blank("._makegen_c.tmp"))
	{
		printf("%s: No C files in current directory\n", argv[0]);
		system("cat ._makegen_c.tmp");
		remove(CTEMPFILE);
		return 1;
	} else {
		remove(CTEMPFILE);
	}

	if (argc == 3 && !strcmp(argv[1], "-o")) {
		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, argv[2]);
		strcpy(_makefile.main_ofile, argv[2]);
		strcpy(_makefile.libs, _DEFAULTS[_LIBS]);
		strcpy(_makefile.install_dir, _DEFAULTS[_INSTALL_DIR]);
		create_makefile();
		delete_tmpfiles();
		return 0;
	} else if (argc == 3 && !strcmp(argv[1], "-L")) {
		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.main_ofile, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.libs, argv[2]);
		strcpy(_makefile.install_dir, _DEFAULTS[_INSTALL_DIR]);
		create_makefile();
		delete_tmpfiles();
		return 0;
	} else if (argc == 3 && !strcmp(argv[1], "-d")) {
		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.main_ofile, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.libs, _DEFAULTS[_LIBS]);
		strcpy(_makefile.install_dir, argv[2]);
		create_makefile();
		delete_tmpfiles();
		return 0;
	} else if (argc == 5 && !strcmp(argv[1], "-o") && !strcmp(argv[3], "-L")) {
		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, argv[2]);
		strcpy(_makefile.main_ofile, argv[2]);
		strcpy(_makefile.libs, argv[4]);
		strcpy(_makefile.install_dir, _DEFAULTS[_INSTALL_DIR]);
		create_makefile();
		delete_tmpfiles();
		return 0;
	} else if (argc == 5 && !strcmp(argv[1], "-o") && !strcmp(argv[3], "-d")) {
		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, argv[2]);
		strcpy(_makefile.main_ofile, argv[2]);
		strcpy(_makefile.libs, _DEFAULTS[_LIBS]);
		strcpy(_makefile.install_dir, argv[4]);
		create_makefile();
		delete_tmpfiles();
		return 0;
	} else if (argc == 5 && !strcmp(argv[1], "-L") && !strcmp(argv[3], "-d")) {
		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.main_ofile, _DEFAULTS[_MAIN_LABEL]);
		strcpy(_makefile.libs, argv[2]);
		strcpy(_makefile.install_dir, argv[4]);
		create_makefile();
		delete_tmpfiles();
		return 0;
	} else if (argc == 7 && !strcmp(argv[1], "-o") && !strcmp(argv[3], "-L") && !strcmp(argv[5], "-d")) {
		mktmpfiles("h");
		mktmpfiles("c");
		mkotmpfile();
		set_deps();
		set_ofiles();
		strcpy(_makefile.main_label, argv[2]);
		strcpy(_makefile.main_ofile, argv[2]);
		strcpy(_makefile.libs, argv[4]);
		strcpy(_makefile.install_dir, argv[6]);
		create_makefile();
		delete_tmpfiles();
		return 0;
	} else {
		printf("Usage: %s [-o prog-name] [-L 'library-args'] [-d install-dir]\n       %s [-h]\n", argv[0], argv[0]);
		return 1;
	}
		
}
