/* Centaur Makefile Generator
 *
 * Version 2.0
 * 11/19/2020
 *
 * Functions to generate Makefiles
 *
 * makegen.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "makegen.h"

int exist(char file[])
{
	FILE *fptr;
	fptr = fopen(file, "r");
	if (!fptr)
	{
		return 0;
	} else {
		rewind(fptr);
		return 1;
	}
}

int blank(char file[])
{
	char _in[8];
	FILE *fptr;
	fptr = fopen(file, "r");
	if (!fptr)
	{
		return -1;
	} else {
		rewind(fptr);
		fgets(_in, 8, fptr);
		if (!strcmp(_in, "") || feof(fptr))
		{
			fclose(fptr);
			return 0;
		} else {
			fclose(fptr);
			return 1;
		}
	}
}

char * strsub(char string[], char find[], char replace[])
{
	char *pch;
	while (1) {
	pch = strstr(string, find);
		if (!pch) {
			break;
		} else {
			strncpy(pch, replace, strlen(replace));
		}
	}
	return string;
}

void mktmpfiles(char ext[5])
{
	char cmdstr[48] = MKTMPSTR;
	strcat(cmdstr, ext);
	strcat(cmdstr, " > ._makegen_");
	strcat(cmdstr, ext);
	strcat(cmdstr, ".tmp");
	system(cmdstr);
	return;
}

void mkotmpfile(void)
{
	FILE *iptr;
	FILE *optr;
	
	char iline[MAXLINELEN];
	
	iptr = fopen(CTEMPFILE, "r");
	if (!iptr)
	{
		printf("Error: File %s missing\n", CTEMPFILE);
		return;
	}
	
	optr = fopen(OTEMPFILE, "w");
	if (!optr)
	{
		printf("Error: Failed to create file %s\n", OTEMPFILE);
		if (iptr)
		{
			fclose(iptr);
		}
		return;
	}
	rewind(iptr);
	while (1)
	{
		fgets(iline, MAXLINELEN, iptr);
		if (feof(iptr))
		{
			break;
		}
		fputs(strsub(iline, ".c", ".o"), optr);
	}
	fclose(iptr);
	rewind(optr);
	fclose(optr);
	return;
}

void set_deps(void)
{
	FILE *fptr;
	char hline[MAXLINELEN];
	char oline[MAXLINELEN] = "";
	char rline[MAXLINELEN];
	fptr = fopen(HTEMPFILE, "r");
	if (!fptr)
	{
		printf("Error: File %s missing\n", HTEMPFILE);
		return;
	}
	rewind(fptr);
	while (1)
	{
		fscanf(fptr, "%s", hline);
		if (feof(fptr))
		{
			break;
		}
		strcat(oline, hline);
		strcat(oline, " ");
	}
	sprintf(_makefile.deps, "%s", strsub(oline, "\n", " "));
	fclose(fptr);
	return;
}

void set_ofiles(void)
{
	FILE *fptr;
	char hline[MAXLINELEN];
	char oline[MAXLINELEN] = "";
	char rline[MAXLINELEN] = "";
	fptr = fopen(OTEMPFILE, "r");
	if (!fptr)
	{
		printf("Error: File %s missing\n", OTEMPFILE);
		return;
	}
	rewind(fptr);
	while (1)
	{
		fscanf(fptr, "%s", hline);
		if (feof(fptr))
		{
			break;
		}
		strcat(oline, hline);
		strcat(oline, " ");
	}
	sprintf(_makefile.ofiles, "%s", strsub(oline, "\n", " "));
	fclose(fptr);
	return;
}

void create_makefile(void)
{
	if (exist("Makefile"))
	{
		char yn[3];
		printf("Warning: Makefile already exists in current directory\n");
		printf("Do you want to overwrite it? (y/n) ");
		scanf("%s", yn);
		if (!strcmp(yn, "y") || !strcmp(yn, "Y") || !strcmp(yn, "yes") || !strcmp(yn, "YES"))
		{
			printf("Makefile in current directory will be overwritten\n");
		} else {
			printf("Cancelling operation\n");
			return;
		}
	}

	FILE *fptr;
	char _file[MAXFILELEN];

	fptr = fopen("Makefile", "w");
	
	if (!fptr)
	{
		printf("Error: Cannot create Makefile in current directory\n");
		return;
	}
	
	if (strcmp(_makefile.libs, ""))
	{
		sprintf(_file, _MAKEFILE, _makefile.deps, _makefile.main_ofile, _makefile.ofiles, _makefile.libs, _makefile.main_ofile, _makefile.ofiles, _makefile.main_ofile, _makefile.install_dir, _makefile.install_dir, _makefile.main_ofile);
		} else {
		sprintf(_file, _MAKEFILE_NOLIBS, _makefile.deps, _makefile.main_ofile, _makefile.ofiles, _makefile.main_ofile, _makefile.ofiles, _makefile.main_ofile, _makefile.install_dir, _makefile.install_dir, _makefile.main_ofile);
	}

	time_t rt;
	struct tm *tptr;
	char date[24];
	time(&rt);
	tptr = localtime(&rt);
	strftime(date, 24, "%m/%d/%Y", tptr);
	
	FILE *hptr;
	char _progname[MAXLINELEN];
	char _version[MAXLINELEN];

	hptr = fopen(MAKEINFO_FILE, "r");

	if (hptr)
	{
		fgets(_progname, MAXLINELEN, hptr);
		fgets(_version, MAXLINELEN, hptr);
		fclose(hptr);
	} else {
		strcpy(_progname, _makefile.main_ofile);
		strcpy(_version, "(unknown)");
	}
	
	if (_progname[(strlen(_progname) - 1)] == '\n')
	{	
		_progname[(strlen(_progname) - 1)] = '\0';
	}

	if (_version[(strlen(_version) - 1)] == '\n')
	{	
		_version[(strlen(_version) - 1)] = '\0';
	}


	sprintf(_header.progname, "# Makefile for %s\n", _progname);
	sprintf(_header.version, "# Version %s\n", _version);
	sprintf(_header.generated, "# Generated %s\n\n", date);

	fputs(_header.progname, fptr);
	fputs(_header.version, fptr);
	fputs(_header.generated, fptr);
	fputs(_file, fptr);

	fclose(fptr);
	#ifdef SHOW_OUTPUT
		char c;
		fptr = fopen(_file, "r");
		rewind(fptr);
		while (1)
		{
			c = fgetc(fptr);
			if (feof(fptr))
			{
				break;
			}
			putchar(c);
		}
	#endif /*SHOW_OUTPUT */
	printf("%s/Makefile created successfully\n", getenv("PWD"));
	return;
}

void delete_tmpfiles(void)
{
	remove(HTEMPFILE);
	remove(CTEMPFILE);
	remove(OTEMPFILE);
	return;
}
